;;; Streams implemented as in SICP

(define-macro (cons-stream head tail)
  `(cons ,head (delay ,tail)) )

(define (head stream)
  (car stream) )

(define (tail stream)
  (force (cdr stream)) )

(define the-empty-stream '())

(define (empty-stream? stream)
  (null? stream) )

;;; end of stream.scm
